<?php
/***************************************************
 *     Setting form
 ***************************************************/
function ga_html_setup($msg = ""){
    $tag_hidden       = 'ga_hidden_setup';
    
    global $current_user;
    get_currentuserinfo();
    
    if (!empty($msg)){
        ga_set_errmsg($msg, true);
    }
    
    $user_level = (integer)$current_user->user_level;
    if ($user_level < 10){
        $msg = array(
            '"Setup" has no authority to change.',
            'Have the authority to change only administrator.'
        );
        ga_set_errmsg($msg, true);
        return ;
    }
    
    if ($_POST[ $tag_hidden ] == "ga_setup"){
        
        // Save Database
        update_option( GA_OPT_CLIENT_ID,     $_POST[GA_OPT_CLIENT_ID] );
        update_option( GA_OPT_CLIENT_SECRET, $_POST[GA_OPT_CLIENT_SECRET] );
        update_option( GA_OPT_ID,            $_POST[GA_OPT_ID] );
        update_option( GA_OPT_RD_AUTH,       $_POST[GA_OPT_RD_AUTH] );
        
        ga_set_errmsg('I save the settings.');
    }
    
    // Load settings from an existing database
    $optval_client_id     = get_option( GA_OPT_CLIENT_ID );
    $optval_client_secret = get_option( GA_OPT_CLIENT_SECRET );
    $optval_id            = get_option( GA_OPT_ID );
    $optval_rd_auth       = get_option( GA_OPT_RD_AUTH );
?>
<h3><?php _e('Setup', 'g_analytics'); ?></h3>
<form name="setup" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
<input name="<?php echo $tag_hidden; ?>" type="hidden" value="ga_setup">
<table class="form-table">
<tbody>
<tr>
    <th><?php _e('Client ID', 'g_analytics');?></th>
    <td>
        <input name="<?php echo GA_OPT_CLIENT_ID; ?>" id="<?php echo GA_OPT_CLIENT_ID; ?>" class="<?php echo GA_OPT_CLIENT_ID; ?>" size="60" type="text" value="<?php echo $optval_client_id; ?>"><br>
        <?php _e('Please enter your client ID of Google Developpers Console.', 'g_analytics'); ?>(<?php _e('Required', 'g_analytics'); ?>) 
    </td>
</tr>
<tr>
    <th><?php _e('Client secret', 'g_analytics');?></th>
    <td>
        <input name="<?php echo GA_OPT_CLIENT_SECRET; ?>" id="<?php echo GA_OPT_CLIENT_SECRET; ?>" class="<?php echo GA_OPT_CLIENT_SECRET; ?>" size="40" type="text" value="<?php echo $optval_client_secret; ?>"><br>
        <?php _e('Please enter your client secret of Google Developpers Console.', 'g_analytics');?>(<?php _e('Required', 'g_analytics'); ?>)
    </td>
</tr>
<tr>
    <th><?php _e('View ID', 'g_analytics');?></th>
    <td>
        <input name="<?php echo GA_OPT_ID; ?>" id="<?php echo GA_OPT_ID; ?>" class="<?php echo GA_OPT_ID; ?>" size="20" type="text" value="<?php echo $optval_id; ?>"><br>
        <?php _e('Please enter the view ID.', 'g_analytics');?>(<?php _e('Required', 'g_analytics'); ?>) (<a href="http://ivystar.jp/cms/wordpress/g-analytics-wordpress/checking-the-profile-id-of-g-analytics/" target="_blank">?</a>)
    </td>
</tr>
<tr>
    <th><?php _e('Reading authority', 'g_analytics');?></th>
    <td>
        <select name="<?php echo GA_OPT_RD_AUTH; ?>" id="<?php echo GA_OPT_RD_AUTH; ?>">
            <option value="10" <?php echo $optval_rd_auth == 10 ? "SELECTED" : ""; ?>><?php _e('Admin', 'g_analytics');?></option>
            <option value="7" <?php echo $optval_rd_auth == 7  ? "SELECTED" : ""; ?>><?php _e('Editor', 'g_analytics');?></option>
            <option value="2" <?php echo $optval_rd_auth == 2  ? "SELECTED" : ""; ?>><?php _e('Author', 'g_analytics');?></option>
            <option value="1" <?php echo $optval_rd_auth == 1  ? "SELECTED" : ""; ?>><?php _e('Contributor', 'g_analytics');?></option>
            <option value="0" <?php echo $optval_rd_auth == 0  ? "SELECTED" : ""; ?>><?php _e('Subscriber', 'g_analytics');?></option>
        </select>
    </td>
</tr>
<tr>
    <th><?php _e('Callback URL', 'g_analytics');?></th>
    <td><?php echo GA_CALLBACK_URL; ?></td>
</tr>
<tr>
    <th><?php _e('Google Developers Console', 'g_analytics');?></th>
    <td><a href="https://console.developers.google.com/" target="_blank">https://console.developers.google.com/</a>
    </td>
</tr>
<tr>
    <td colspan="2">
        <p class="submit">
            <input type="submit" class="button-primary" name="Submit" value="<?php _e('Save Chenge', 'g_analytics');?>">
        </p>
    </td>
</tr>
<tbody>
</table>
</form>
<?php
}
