<?php
/***************************************************
 * Top of the page output
 *--------------------------------------------------
 * @param object $api
 * @param string $optval_ga_id
 * @param string $period
 ***************************************************/
function ga_get_top($api, $optval_ga_id, $period){

    $p_date = ga_get_date($period);
    $today = date('Y-m-d');
    $yesterday = date('Y-m-d', strtotime('-1 day'));
    
    $api->ids = $optval_ga_id;
    
    // Chart data
    $arr_chart_data = @$api->data('ga:date',
                                  'ga:visitors,ga:pageviews,ga:visits',
                                  'ga:date',
                                  $p_date['start_date'],
                                  $p_date['end_date'],
                                  $p_date['max_results']);
    
    // Top data
    $arr_metric = array(
        0 => 'ga:bounces',
        1 => 'ga:entrances',
        2 => 'ga:pageviews',
        3 => 'ga:timeOnPage',
        4 => 'ga:timeOnSite',
        5 => 'ga:visits',
        6 => 'ga:uniquePageviews',
        7 => 'ga:newVisits',
    );
    $arr_metric_data = @$api->data('',
                                   implode(",", $arr_metric),
                                   false,
                                   $p_date['start_date'],
                                   $p_date['end_date']);
    if (empty($arr_metric_data[0])){
        $arr_metric_data = array_flip($arr_metric);
        foreach($arr_metric_data as $key => $val){
            $arr_metric_data[$key] = 0;
        }
    }else{
        $arr_metric_data = array_combine($arr_metric, $arr_metric_data[0]);
    }
    
    // Unique Users
    $metric = 'ga:visitors';
    $arr_metric_visitors_data = @$api->data('ga:date',
                                            $metric,
                                            'ga:date',
                                            $p_date['start_date'],
                                            $p_date['end_date'],
                                            $p_date['max_results']);
    $cnt_visitors = 0;
    if (is_array($arr_metric_visitors_data)){
        foreach($arr_metric_visitors_data as $val){
            $cnt_visitors = $cnt_visitors + (integer)$val[1]; // ga:visitors
        }
    }
    
    //Accessed by page number';
    $metric  = 'ga:pageviews';
    $arr_metric_accpage_today_data = @$api->data('ga:pagePath',
                                                 $metric,
                                                 false,
                                                 $today,
                                                 $today,
                                                 10);
    $arr_metric_accpage_yesterday_data = @$api->data('ga:pagePath',
                                                     $metric,
                                                     false,
                                                     $yesterday,
                                                     $yesterday,
                                                     10);
    
    $p_date = ga_get_date($period, '/');
    
    $utime_start = strtotime($p_date['start_date']);
    $utime_end   = strtotime($p_date['end_date']);
    $uday_term   = ($utime_end - $utime_start) / ( 60 * 60 * 24 );
    
    // Get Rss Data
    $arr_rss = ga_get_rss(GA_IVYSTR_RSS, 3);
    
    $api_err = $api->error;
    if (!empty($api_err)){
        ga_set_errmsg($api_err, true);
    }
    
    echo '<h3>'.__('Top', 'g_analytics').'</h3>';
    
?>
<div style="margin-bottom: 1em;width:99%;">
    <table class="topcnt">
        <tbody id="the-comment-list" class="list:comment">
        <thead>
            <tr>
                <th scope="col"><?php _e('Date', 'g_analytics'); ?></th>
                <td colspan="3">
                    <?php echo $p_date['start_date']; ?>
                    -
                    <?php echo $p_date['end_date']; ?>
                </td>
            </tr>
            <tr>
                <th scope="col"><?php _e('Visits', 'g_analytics'); ?>(<?php _e('Total', 'g_analytics'); ?>/<?php _e('Average', 'g_analytics'); ?>)</th>
                <td>
                    <?php if (is_array($arr_metric_data)){ echo $arr_metric_data['ga:visits']; } ?>
                    /
                    <?php if (is_array($arr_metric_data) && $uday_term != 0){ echo round( $arr_metric_data['ga:visits'] / $uday_term , 0 ); } ?>
                </td>
                
                <th scope="col"><?php _e('Pageviews', 'g_analytics'); ?>(<?php _e('Total', 'g_analytics'); ?>/<?php _e('Average', 'g_analytics'); ?>)</th>
                <td>
                    <?php if (is_array($arr_metric_data)){ echo $arr_metric_data['ga:pageviews']; } ?>
                    /
                    <?php if (is_array($arr_metric_data) && $uday_term != 0){ echo round( $arr_metric_data['ga:pageviews'] / $uday_term, 0 ); } ?>
                </td>
            </tr>
            <tr>
                <th scope="col"><?php _e('Unique Users', 'g_analytics'); ?>(<?php _e('Total', 'g_analytics'); ?>/<?php _e('Average', 'g_analytics'); ?>)</th>
                <td>
                    <?php if (!empty($cnt_visitors)){ echo $cnt_visitors; } ?>
                    /
                    <?php if (!empty($cnt_visitors) && $uday_term != 0){ echo round( $cnt_visitors / $uday_term, 0 ); } ?>
                </td>
                
                <th scope="col"><?php _e('Bounce Rate', 'g_analytics'); ?></th>
                <td>
                    <?php
                        $bounce_rate = '';
                        if (is_array($arr_metric_data)){
                            if (!empty($arr_metric_data['ga:bounces']) && !empty($arr_metric_data['ga:entrances'])){
                                $bounce_rate = round( $arr_metric_data['ga:bounces'] / $arr_metric_data['ga:entrances'], 4 ) * 100;
                            }
                        }
                        echo $bounce_rate;
                    ?>
                </td>
            </tr>
            <tr>
                <th scope="col"><?php _e('Average Pageviews', 'g_analytics'); ?></th>
                <td>
                    <?php
                        $average_ageviews = '';
                        if (is_array($arr_metric_data)){
                            if (!empty($arr_metric_data['ga:pageviews']) && !empty($arr_metric_data['ga:visits'])){
                                $average_ageviews = round( $arr_metric_data['ga:pageviews'] / $arr_metric_data['ga:visits'], 2 );
                            }
                        }
                        echo $average_ageviews;
                    ?>
                </td>
                
                <th scope="col"><?php _e('Time on Site', 'g_analytics'); ?></th>
                <td>
                    <?php
                        $time_site = '';
                        if (is_array($arr_metric_data)){
                            if (!empty($arr_metric_data['ga:timeOnPage']) && !empty($arr_metric_data['ga:visits'])){
                                $time_site = gmdate('H:i:s', $arr_metric_data['ga:timeOnPage'] / $arr_metric_data['ga:visits']);
                            }
                        }
                        echo $time_site;
                    ?>
                </td>
            </tr>
        </thead>
    </table>
</div>

<script id="source" language="javascript" type="text/javascript">
jQuery(function () {
<?php
    $d_visitors  = array();
    $d_pageviews = array();
    $d_visits    = array();
    foreach($arr_chart_data as $val){
        $date_key = $val[0];
        $date_key = (mktime(0, 0, 0, substr($date_key,4,2), substr($date_key,6,2), substr($date_key,0,4)) + date('Z')) * 1000;
        $d_pageviews[] = '['.$date_key.','.$val[2].']'; // ga:pageviews
        $d_visitors[]  = '['.$date_key.','.$val[1].']'; // ga:visitors
        $d_visits[]    = '['.$date_key.','.$val[3].']'; // ga:visits
    }
    $d_visitors  = implode(', ', $d_visitors);
    $d_pageviews = implode(', ', $d_pageviews);
    $d_visits    = implode(', ', $d_visits);
    
?>
    var d1 = [<?php echo $d_pageviews;?>];
    var d2 = [<?php echo $d_visits;?>];
    var d3 = [<?php echo $d_visitors;?>];
    
    var plot = jQuery.plot(
           jQuery("#placeholder"),
           [ { color: "#EDC240", data: d1, label: "<?php _e('Pageviews', 'g_analytics'); ?>" },
             { color: "#AFD8F8", data: d2, label: "<?php _e('Visits', 'g_analytics'); ?>" },
             { color: "#BFFFCE", data: d3, label: "<?php _e('Unique Users', 'g_analytics'); ?>" } ],
           { lines: { show: true },
             points: { show: true },
             grid: { hoverable: true, autoHighlight: true },
             xaxis: { mode: 'time', timeformat: "%m/%d" },
             yaxis: { min: 0 },
             legend: { position: 'n', noColumns: 3, margin: -30 } }
           );

    function showTooltip(x, y, contents) {
        jQuery('<div id="tooltip">' + contents + '</div>').css( {
            position: 'absolute',
            display: 'none',
            top: y + 5,
            left: x + 5,
            border: '1px solid #AFFFFF',
            padding: '2px',
            'background-color': '#DFFFFF',
            opacity: 0.80
        }).appendTo("body").fadeIn(200);
    }

    function GetDate(UnixTime){
        var datearray = new Array(3);
        var dd = new Date();
        dd.setTime(UnixTime * 1000);
        datearray[0] = dd.getYear();
        if(datearray[0] < 1900){ datearray[0] += 1900;}
        datearray[1] = dd.getMonth() + 1;
        datearray[2] = dd.getDate();
        for(var count = 3; count < 6; count++){
            if(datearray[count] < 10){ datearray[count] = "0"+datearray[count] }
        }
        return datearray;
    }

    var previousPoint = null;
    jQuery("#placeholder").bind("plothover", function (event, pos, item) {
        if (item) {
            if (previousPoint != item.datapoint) {
                previousPoint = item.datapoint;
                
                jQuery("#tooltip").remove();
                var x = item.datapoint[0];
                var y = item.datapoint[1];
                var dt = GetDate( x / 1000 );
                
                showTooltip(item.pageX, item.pageY,
                            item.series.label + " : " + dt[0] + "/" + dt[1] + "/" + dt[2] + " = " + y);
            }
        } else {
            jQuery("#tooltip").remove();
            previousPoint = null;            
        }
    });

});
</script>

<div id="grapharea">
    <div style="width:99%;height:20px;margin:0 auto;background-color:#FFFFFF;"></div>
    <div id="placeholder" style="width:95%;height:350px;margin:0 auto;background-color:#FFFFFF;"></div>
</div>

<div class="topbest">
    <h4><?php _e('Today\'s popularity article', 'g_analytics');?></h4>
    
    <table class="topbest_table">
        <thead>
            <tr>
                <th><?php _e('Title', 'g_analytics');?></th>
                <th style="width:80px;text-align:right;"><?php _e('Pageviews', 'g_analytics');?></th>
            </tr>
<?php
    if (is_array($arr_metric_accpage_today_data)){
        $siteurl = get_option('siteurl');
        foreach($arr_metric_accpage_today_data as $val){
            echo '<tr>';
            echo '<td><a href="'.$val[0].'">';
            
            if (preg_match('/preview=true/', $val[0])){
                echo "(".__('Preview', 'g_analytics').")";
            }else{
                echo ga_get_title($val[0]);
            }
            
            echo '</a></td>';
            echo '<td style="text-align:right;">'.$val[1].'</td>';
            echo '</tr>';
        }
    }
?>
        </thead>
        </tbody>
    </table>
</div>
    
<div class="topbest">
    <h4><?php _e('Yesterday\'s popularity article', 'g_analytics');?></h4>
    
    <table class="topbest_table">
        <thead>
            <tr>
                <th><?php _e('Title', 'g_analytics');?></th>
                <th style="width:80px;text-align:right;"><?php _e('Pageviews', 'g_analytics');?></th>
            </tr>
<?php
    if (is_array($arr_metric_accpage_yesterday_data)){
        $siteurl = get_option('siteurl');
        foreach($arr_metric_accpage_yesterday_data as $val){
            echo '<tr>';
            echo '<td class="title"><a href="'.$val[0].'">';
            
            if (preg_match('/preview=true/', $val[0])){
                echo "(".__('Preview', 'g_analytics').")";
            }else{
                echo ga_get_title($val[0]);
            }
            
            echo '</a></td>';
            echo '<td  class="value">'.$val[1].'</td>';
            echo '</tr>';
        }
    }
?>
        </thead>
        </tbody>
    </table>
    
</div>
<div class="clear"></div>

<h4><?php _e('Ivystar RSS information', 'g_analytics');?></h4>
<div id="rssarea">
    <ul style="list-style: disc inside;">
    <?php
    if (empty($arr_rss)){
        _e("RSS information could not be obtained.", 'g_analytics');
        _e("Please see <a href='http://ivystar.jp'>here</a> if you look at the blog information.", 'g_analytics');
    }else{
        foreach($arr_rss as $rss){
    ?>
        <li><?php echo $rss['date']; ?> <a href="<?php echo $rss['link']; ?>" target="_blank"><?php echo $rss['title']; ?></a> </li>
    <?php
        }
    }
    ?>
    </ul>
</div>

<?php
}
/********** Function ga_get_top() END **********/


